' OSDMsgBox.vbs "strTSVar" "prompt" ["buttons"] ["title"] ["returncodemap"]

' The OSDMsgBox function displays a message box, waits for the user to click a button,
' and returns a value that indicates which button the user clicked in the given OSD Variable.

arrReturn = Array("OK", "Cancel", "Abort", "Retry", "Ignore", "Yes", "No")

' MsgBox(prompt[,buttons][,title])
'
' Parameter Description
'
'  prompt : Required. The message to show in the message box. Maximum length is 1024 characters.
'                     You can separate the lines using a carriage return character (Chr(13)), a linefeed character (Chr(10)),
'                     or carriage returnlinefeed character combination (Chr(13) & Chr(10)) between each line.
'
'  buttons: Optional. A value or a sum of values that specifies the number and type of buttons to display,
'                     the icon style to use, the identity of the default button, and the modality of the message box.
'                     Default value is 0.
'
'     0 = vbOKOnly           - OK button only
'     1 = vbOKCancel         - OK and Cancel buttons
'     2 = vbAbortRetryIgnore - Abort, Retry, and Ignore buttons
'     3 = vbYesNoCancel      - Yes, No, and Cancel buttons
'     4 = vbYesNo            - Yes and No buttons
'     5 = vbRetryCancel      - Retry and Cancel buttons
'    16 = vbCritical         - Critical Message icon
'    32 = vbQuestion         - Warning Query icon
'    48 = vbExclamation      - Warning Message icon
'    64 = vbInformation      - Information Message icon
'     0 = vbDefaultButton1   - First button is default
'   256 = vbDefaultButton2   - Second button is default
'   512 = vbDefaultButton3   - Third button is default
'   768 = vbDefaultButton4   - Fourth button is default
'  4096 = vbSystemModal      - System modal (all applications wont work until the user responds to the message box)
'
'  title: Optional. The title of the message box. Default is the application name
'
On Error Resume Next
Set env = CreateObject("Microsoft.SMS.TSEnvironment")

Set objArgs = WScript.Arguments

cArgs=objArgs.Count

If cArgs>1 Then
	strTSVar = CStr(objArgs.Item(0))
	strMsgBoxPrompt = Replace(CStr(objArgs.Item(1)),"#CRLF#",vbCRLF,1,-1,1)
Else
	WScript.Quit
End If

If cArgs>2 Then
	iMsgBoxButtons = 4+32+4096 ' initialize with a default because following conversion might fail
	iMsgBoxButtons = CInt(objArgs.Item(2))+4096
Else
	iMsgBoxButtons = 4+32+4096
End If

If cArgs>3 Then
	strMsgBoxTitle = CStr(objArgs.Item(3))
Else
	strMsgBoxTitle = env("_SMSTSPackageName")
End If

iReturn = MsgBox(strMsgBoxPrompt, iMsgBoxButtons, strMsgBoxTitle)
env(strTSVar) = arrReturn(iReturn-1)

if cArgs>4 Then
	arrReturnCodes=Split(CStr(objArgs.Item(4))," ")
	WScript.Quit (arrReturnCodes(iReturn-1))
End If

'WScript.Echo "OSDMsgBox returns: " & Chr(34) & arrReturn(iReturn-1) & Chr(34)
