' Set Task Sequence Variable using a WMI query
'  (C) Thorsten Lau, Nov. 2011
'
' synopsis:
' 	SetTSVarByWMI.vbs <VariablePrefix> <WMIQuery>
' example:
' 	SetTSVarByWMI.vbs TSCS "select Model from Win32_Computersystem"
'		sets variables TSCS_Model and TSCS_Name
' 		(Note: Name is not in the select list but is set because it is the key attribute)
'

Function ConvertPropertyValueToString(ByVal PropertyValue)
	On Error Resume Next
	If IsObject(PropertyValue) Then
		ConvertPropertyValueToString = "" ' <CIM_OBJECT (embedded SWbemObject)>
	ElseIf IsNull(PropertyValue) Then
		ConvertPropertyValueToString = "" ' NULL
	ElseIf IsArray(PropertyValue) Then
		' ConvertPropertyValueToString = Join(PropertyValue, ",")
		ConvertPropertyValueToString = CStr(PropertyValue(0))
	Else
		ConvertPropertyValueToString = CStr(PropertyValue)
	End If
End Function

On Error Resume Next

strVarName = WScript.Arguments(0)
strQuery   = WScript.Arguments(1)

Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
Set env = CreateObject("Microsoft.SMS.TSEnvironment")

set QueryRes = objWMIService.ExecQuery(strQuery)

For Each objRes in QueryRes
	For Each objProperty In objRes.Properties_
		strPropertyValue = ConvertPropertyValueToString(objProperty.Value)
		WScript.Echo strVarName & "_" & objProperty.Name & " = " & strPropertyValue
		env(strVarName & "_" & objProperty.Name) = strPropertyValue
	Next
	Exit For ' return first instance only
Next
